﻿using System;
using System.Collections.Generic;

using NXOpen;
using NXOpen.UF;
using NXOpen.Assemblies;
using NXOpen.Drawings;
using NXOpen.Utilities;

namespace ClassLibrary1
{
    class Class2
    {

        public static void Main(string[] args)
        {

            Session theSession = Session.GetSession();
            UFSession ufs = UFSession.GetUFSession();
            ListingWindow lw = theSession.ListingWindow;
            List<NXObject> comps = new List<NXObject>();

            Part workPart = theSession.Parts.Work;

            lw.Open();

            BaseView baseView = (BaseView)workPart.DraftingViews.FindObject("VIEW@1");

            DisplayableObject[] objs = baseView.AskVisibleObjects();

            foreach (DisplayableObject obj in objs)
            {

                bool b_isso = false;
                ufs.So.IsSo(obj.Tag, out b_isso);
                if (!b_isso) continue;

                if (obj is Line || obj is Arc)
                {

                    lw.WriteLine(" ");
                    lw.WriteLine("  Object: " + obj.ToString());

                    int n_parents = 0;
                    NXOpen.Tag[] parents = null;
                    ufs.So.AskParents(obj.Tag, UFConstants.UF_SO_ASK_ALL_PARENTS, out n_parents, out parents);

                    foreach (NXOpen.Tag parent in parents)
                    {

                        NXObject parent_obj = (NXObject)NXObjectManager.Get(parent);

                        lw.WriteLine("   Parent: " + parent_obj.ToString());
                        lw.WriteLine("    Occurrence?: " + parent_obj.IsOccurrence.ToString());

                        if (obj is Line)
                        {
                            UFCurve.Line line_coords;
                            ufs.Curve.AskLineData(obj.Tag, out line_coords);
                            string s_Start = string.Format("{0}/{1}/{2}", line_coords.start_point[0], line_coords.start_point[1], line_coords.start_point[2]);
                            string s_Ende = string.Format("{0}/{1}/{2}", line_coords.end_point[0], line_coords.end_point[1], line_coords.end_point[2]);
                            lw.WriteLine("     Start: " + s_Start);
                            lw.WriteLine("     Ende:  " + s_Ende);
                        }

                        if (parent_obj.IsOccurrence)
                        {

                            lw.WriteLine("    Owning Component: " + parent_obj.OwningComponent.DisplayName);

                            if (!comps.Contains(parent_obj.OwningComponent))
                            {
                                comps.Add(parent_obj.OwningComponent);
                            }
                        
                        }
                    
                    }
                
                }
            
            }


            /*


          For Each comp As Component In comps
            lw.WriteLine("    Component: " & comp.DisplayName)
            Dim loaded As Boolean = ufs.Part.IsLoaded(comp.DisplayName)
            If loaded = 0 Then
              lw.WriteLine("     -> (unloaded)")
            Else
              Dim c_part As Part = DirectCast(comp.Prototype, Part)
              lw.WriteLine("     Fully Loaded?: " & c_part.IsFullyLoaded.ToString())
              lw.WriteLine("     Full Path: " & c_part.FullPath)
            End If
          Next comp

        Next
         
        
             */

        }

    }
}
